                         PAGE 60,132
             TITLE       INDEX (EXE) SELECCION DE UNA OPCION DEL MENU
                         EXTRN  VIDEOINVERSO:FAR
                         EXTRN  ACEPTANOMBRE:FAR
             ; ================================================================
                         .MODEL SMALL
                         .STACK 64
             ; ================================================================
                         .DATA
             FILASUPER   EQU   00                ;hilera superior del menu
             FILAINFER   EQU   04                ;hilera inferior del menu
             XCOLUMNIZQ  EQU   10                ;Columna izquieda del menu
             XCOLUMNA    DB    00                ;Columna de la pantalla
             XFILA       DB    00                ;hilera de la pantalla
             XCONTADOR   DB    ?                 ;caracteres por linea
             XLINEAS     DB    ?                 ;lineas exhibidas
             ATRIBUTOX   DB    ?                 ;atributo de pantalla
             ANCHOX      DB    19                ;ancho del menu
           
             MENU         DB      0C9H, 17 DUP (0CDH), 0BBH
			  DB      0BAH,   'VIDEO INVERSO    ',0BAH
                          DB      0BAH,   'ACEPTA NOMBRE    ',0BAH
                          DB      0BAH,   'SALIR            ', 0BAH
                          DB      0C8H,    17 DUP (0CDH), 0BCH

             PROMPT      DB    09,'Para seleccionar un item, use las cursoras,'
                         DB    ' y presione ENTER.'
                         DB    13, 10, 09, 'Pulse ESC para salir'
             ; ================================================================
                        .CODE
             INDEX      PROC  FAR                       ;Procedimiento principal
                        PUBLIC INDEX                    ;Declarandolo publico
                         
                        MOV   AX,@DATA                  ;iniciar registros
                        MOV   DS,AX                     ; de segmento
                        MOV   ES,AX
                         
                        CALL  PLIMPIAR                  ;despejar pantalla
                        MOV   XFILA,FILAINFER+5		;Margen del menu al PROMPT
                        MOV   XCOLUMNA,00		;Margen izquierdo del PROMPT al MENU
                        CALL  PCURSOR                   ;fijar cursor
                        MOV   AH,40H                    ;peticion de exhibion
                        MOV   BX,01                     ;manejo de pantalla
                        MOV   CX,85                     ;numero de caracteres
                        LEA   DX,PROMPT                 ;indicacion
                        INT   21H       		;Peticion al DOS
             A10LOOP:
                         CALL  SHOWMENU                 ;exhibicion de menu
                         MOV   XCOLUMNA,XCOLUMNIZQ+1	;
                         CALL  PCURSOR                  ;fijar cursor
                         MOV   XFILA,FILASUPER+1        ;fijar hilera a opcion superior
                         MOV   ATRIBUTOX,16H            ;fijar video inverso
                         CALL  PVIDNORMAL               ;resaltar la linea de menu
                         CALL  SELECMENU                ;proporcionar para la seleccion de menu
                         CMP   AL,1BH                   ;presion del enter?
                         JNE   A10LOOP                  ;     si, continuar
                         MOV   AX,0600H                 ;esc presionado (fin)
                         CALL  PLIMPIAR                 ;despejar pantalla
                         MOV   AX,4C00H                 ;salida al DOS
                         INT   21H			;Peticion al DOS
             INDEX       ENDP

              ;                 MOSTRAR TODO EL MENU:
             ; ================================================================	
             SHOWMENU   PROC  NEAR			;Inicio procedimiento MostraMenu
                        MOV   XFILA,FILASUPER           ;fijar hilera superior
                        MOV   XLINEAS,05                ;numero de filas
                        LEA   SI,MENU			;Cargar en el SOURCE INDEX la variable MENU
                        MOV   ATRIBUTOX,71H             ;azul sobre blanco
             E_REGRESAR:
                        MOV   XCOLUMNA,XCOLUMNIZQ       ;fijar Columna izquierda del menu
                        MOV   XCONTADOR,19		;Contar si se mostraron todas las columnas (19)
             E_REPETIR:
                        CALL  PCURSOR           	;fijara cursor en la siguiente Columna
                        MOV   AH,09H            	;peticion de exhibicion
                        MOV   AL, [SI]          	;obtener caracter del menu
                        MOV   BH,00             	;pagina 0
                        MOV   BL,71H            	;nuevo atributo
                        MOV   CX,01             	;un caracter 
                        INT   10H			;Llama al BIOS (manejo de pantalla)
                        INC   XCOLUMNA         	 	;siguiente Columna
                        INC   SI                	;fijar siguiente caracter
                        DEC   XCONTADOR         	;ultimo caracter?
                        JNZ   E_REPETIR                 ; no, repetir
                        INC   XFILA                     ;Siguiente fila
                        DEC   XLINEAS
                        JNZ   E_REGRESAR                ;se imprimieron todas las lineas?
                        RET                             ;si es asi, regresar
             SHOWMENU   ENDP
             ;                 ACEPTAR ENTRADA A PEDIDO
             ; ================================================================
             SELECMENU  PROC  NEAR
                        MOV   AH,10H                    ;peticion de entrada
                        INT   16H                       ;     del teclado
                        CMP   AH,50H                    ;flecha hacia abajo?
                        JE    D20
                        CMP   AH,48H                    ;flecha hacia arriba?
                        JE    D30
                        CMP   AL,0DH                    ;enter(tecla)?
                        JE    SEL_OPCION                ;Opcion seleccionada
                        CMP   AL,1BH                    ;escape(tecla)?
                        JE    SALIDA_MENU
                        JMP   SELECMENU                 ;ninguna, procesar de nuevo
             D20:       MOV   ATRIBUTOX,71H             ;azul sobre blanco
                        CALL  PVIDNORMAL                ;fijar la linea anterior a video normal
                        INC   XFILA
                        CMP   XFILA,FILAINFER-1         ;se paso la hilera interior?
                        JBE   E_VINVERSO                ;no, muy bien
                        MOV   XFILA,FILASUPER+1         ; si, restablecer
                        JMP   E_VINVERSO
             D30:       MOV   ATRIBUTOX,71H             ;video normal
                        CALL  PVIDNORMAL                ;fijar linea anterior a video normal
                        DEC   XFILA
                        CMP   XFILA,FILASUPER+1         ;abajo de la hilera superior?
                        JAE   E_VINVERSO                ; no, muy bien
                        MOV   XFILA,FILAINFER-1         ; si, restablecer
             E_VINVERSO:
                        CALL  PCURSOR                   ;fijar cursor
                        MOV   ATRIBUTOX,16H             ;video inverso
                        CALL  PVIDNORMAL                ;fijar nueva linea a video inverso
                        JMP   SELECMENU
             SEL_OPCION:
                        CMP   XFILA,1                   ;compara si se encuentra  en la fila 1
                        JE    OPCION1                   ;si es asi se va  a la etiqueta menu 1
                        CMP   XFILA,2
                        JE    OPCION2
                        CMP   XFILA,3
                        JE    SALIDA_MENU
                        JMP   SALIR
             OPCION1:
                        CALL  PLIMPIAR                  ;Limpia pantalla
                        CALL  VIDEOINVERSO              ;este llama al subprograma localizado en SUBPROG2
                        JMP   SALIR
             OPCION2:
                        CALL  PLIMPIAR                  ;Limpia pantalla
                        CALL  ACEPTANOMBRE              ;este llama al subprograma localizado en SUBPROG1
                        JMP   SALIR

             SALIDA_MENU:
                        CALL  PLIMPIAR                        
                        MOV   AX,4C00H                  ;Se sale a dos
                        INT   21H      
             SALIR:
                         RET

             SELECMENU  ENDP


             ;                 FIJAR LINEA DE MENU A NORMAL/RESALTADA
             ; ================================================================
             PVIDNORMAL PROC  NEAR
                        MOV   AH,00
                        MOV   AL,XFILA                  ;la hilera dice que linea fijar
                        MUL   ANCHOX                    ;multiplica por la longitud de la linea
                        LEA   SI,MENU+1                 ;     por la linea de menu seleccionada
                        ADD   SI,AX
                        MOV   XCONTADOR,17              ;caracteres a exhibir
             H20:
                        CALL  PCURSOR                   ;fijar cursor en segmento Columna
                        MOV   AH,09H                    ;Manejador de caracteres
                        MOV   AL,[SI]
                        MOV   BH,00
                        MOV   BL,ATRIBUTOX
                        MOV   CX,01
                        INT   10H
                        INC   XCOLUMNA                  ;Incrementar columna
                        INC   SI                        
                        DEC   XCONTADOR                 
                        JNZ   H20
                        MOV   XCOLUMNA,XCOLUMNIZQ+1
                        CALL  PCURSOR
                        RET
            PVIDNORMAL  ENDP
            ;                  DESPEJAR PANTALLA
             ; ================================================================
            PLIMPIAR     PROC  NEAR
                         MOV   AX,0600H                 ;Recorre toda la pantalla
                         MOV   BH,71H                   ;Atributo de color 
                         MOV   CX,0000                  ;Esquina superior izq
                         MOV   DX,184FH                 ;Esquina inferiro derecha
                         INT   10H                      ;Llama al BIOS
                         RET
           PLIMPIAR      ENDP

            ;                  FIJAR CURSOR
            ; ================================================================
           PCURSOR      PROC   NEAR
                        MOV    AH,02H                   ;Manejador para desplegar un caracter
                        MOV    BH,00                    ;Pagina
                        MOV    DH,XFILA                 ;Fila
                        MOV    DL,XCOLUMNA              ;Columna
                        INT    10H                      ;Llama al BIOS
                        RET
          PCURSOR       ENDP
                        END    INDEX
