;***************
;**  PAG 348  **
;***************



TITLE   leeAscii (EXE)
        .MODEL SMALL
        .STACK 64
;=======================================================================:
        .DATA
ARDESPX DB      120 DUP(' ')          ; rea de despliegue
FINALCD  DW      00                    ; Indicador del fin del proceso
MANEJAX  DW      0                     ; Manejador de archivo
ABRMSG   DB      '*Error de lectura*'
RUTANOMB DB      'c:\windows\axembler.dat',0
FILAX    DB      00
INTROX   DB      512 DUP(' ')          ;rea de entrada
;=======================================================================:
        .CODE
P3B 	PROC    FAR
        MOV     AX,@data              	; Inicializa
        MOV     DS,AX                 	; registros de
        MOV     ES,AX                 	; segmentos
        MOV     AX,0600H
        CALL    LIMPANT                 ; Limpia la pantalla
        CALL    FIJCURS                 ; Coloca el cursor
        CALL    ABRARCH                 ; Abre archivo
        CMP     FINALCD,00              ; Apertura vlida?
        JNE     BUCLE1                  ; no, salir
BUCLE2:                                 ; s, continuar
        CALL    XLEER                 	; Lee primer sector del disco
        CMP     FINALCD,00              ; fin de archivo, no hay datos?
        JE      BUCLE1                  ; s, salir
        CALL    TRANSFEX                ; Despliega y lee
BUCLE1:
        MOV     AH,3EH                  ; Peticin para cerrar archivo
        MOV     BX,MANEJAX
        INT     21H
        MOV     AX,4C00H                ; Sale al DOS
        INT     21H
P3B ENDP
;                      Abre archivo en disco:
ABRARCH PROC    NEAR
        MOV     AH,3DH                  ; Peticin para abrir
        MOV     AL,00                   ; Slo lectura
        LEA     DX,RUTANOMB
        INT     21H
        JNC     BUCLE3                     ; Examina bandera de acarreo,
        CALL    ERRORX                  ; Si est en uno, error
        RET
BUCLE3:
        MOV     MANEJAX,AX               ; Guardar manejador
        RET
        ABRARCH ENDP
;                     Transfiere datos a la lnea de despliegue:
;=======================================================================:
TRANSFEX PROC    NEAR
        CLD                             ; De izquierda a derecha
        LEA     SI,INTROX
BUCLE4:
        LEA     DI,ARDESPX
BUCLE5:
        LEA     DX,INTROX+512
        CMP     SI,DX                   ; Fin del sector?
        JNE     BUCLE99                     ; no, pasar
        CALL    XLEER                 	; s; lee el siguiente
        CMP     FINALCD,00              ; Fin del archivo
        JE      BUCLE55                 ; s, salir
        LEA     SI,INTROX
BUCLE99:
        LEA     DX,ARDESPX+80
        CMP     DI,DX                   ; Fin de ARDESPX?
        JB      BUCLE900                ; no, pasar
        MOV     [DI],0D0AH              ; s, establecer CR/LF y
        CALL    DISPLAX                 ; desplegar
        LEA     DI,ARDESPX
BUCLE900:
        LODSB                           ; [SI] a AL; INC SI
        STOSB                           ; AL a [DI], INC DI
        CMP     AL,1AH                  ; Fin del archivo?
        JE      BUCLE55                     ; s, salir
        CMP     AL,0AH                  ; Avanza lnea?
        JNE     BUCLE5                     ; no, repetir el ciclo
        CALL    DISPLAX                 ; s, desplegar
        JMP     BUCLE4
BUCLE55:
        CALL    DISPLAX                 ; Despliega ltima lnea
BUCLEX44:    RET
TRANSFEX ENDP      










;Despliega linea:
;=======================================================================:

DISPLAX	PROC	NEAR
	MOV	AH,40H			;Peticion de despliegue
	MOV	BX,01			;Manejador
	LEA	CX,ARDESPX		;Calcula
	NEG	CX			; la longitud
	ADD	CX,DI			; de la linea
	LEA	DX,ARDESPX
	INT	21H
	CMP	FILAX,22		;Inferior de la pantalla?
	JAE	HBUCLE21		; no, salir
	INC	FILAX
	JMP	HBUCLE90
HBUCLE21:
	MOV	AX,0601H		;Recorre
	CALL	LIMPANT
	CALL	FIJCURS
HBUCLE90:	RET
DISPLAX	ENDP

;Recorre pantalla:
LIMPANT	PROC	NEAR			;AX, se designa antes
	MOV	BH,1EH			;Designa atributo de color
	MOV	CX,0000			;Recorre
	MOV	DX,184FH
	INT	10H
	RET
LIMPANT	ENDP

;Coloca el cursor
FIJCURS	PROC	NEAR
	MOV	AH,02H			;Peticion para
	MOV	BH,00			; colocar el cursor
	MOV	DH,FILAX
	MOV	DL,00
	INT	10H
	RET
FIJCURS	ENDP

;Lee INTROX de disco:
XLEER	PROC	NEAR
	MOV	AH,3FH			;Peticion para leer
	MOV	BX,MANEJAX		;Dispositivo
	MOV	CX,512			;Longitud
	LEA	DX,INTROX		;Bufer
	INT	21H
	MOV	FINALCD,AX
	RET
XLEER	ENDP

;Despliega mensaje de error de disco
ERRORX	PROC	NEAR
	MOV	AH,40H			;Peticion para desplegar
	MOV	BX,01			;Manejador
	MOV	CX,18			;Longitud
	LEA	DX,ABRMSG
	INT	21H
	MOV	FINALCD,01		;Indicador de error
	RET
ERRORX	ENDP
	END	P3B  

