;***************
;**  PAG 143  **
;***************


TITLE   CENTRANOMBRE (EXE)
;===============================================================================:
        .MODEL SMALL
        .STACK 64
;===============================================================================:
        .DATA
PARAM 	LABEL   BYTE			;Lista de parametros nombre:
MAXIMA 	DB      20			;  longitud maxima de nombre
NLONG 	DB      ?			;  no. de caracteres introducidos
CAMPO DB      21 DUP(' ')		;  nombre introducido
PROMPT  DB      'Nombre? ', '$'
;===============================================================================:
        .CODE
BEGIN   PROC    FAR
        MOV     AX,@data		;Iniciar registros
        MOV     DS,AX			;  de segmento
        MOV     ES,AX
        CALL    LIMPIAR			;Despejar pantalla
LAZO1:
        MOV     DX,0000			;Fijar cursor en 00,00
        CALL    CURSOR
        CALL    PETIC			;Desplegar prompt
        CALL    ENTRADA			;Proporciona entradas del nombre
        CALL    LIMPIAR			;Despejar pantalla
        CMP     NLONG,00		;Se ingreso el nombre?
        JE      LAZO2			;  no, salida
        CALL    CODIGO			;Fijar beep y '$'
        CALL    CENTRAR			;Centra y muestra el nombre
        JMP     LAZO1
LAZO2:			
        MOV     AX,4C00H		;Salir al DOS
        INT     21H
BEGIN   ENDP


;	Muestra el prompt
;===============================================================================:
PETIC 	PROC    NEAR
        MOV     AH,09H 			;Peticion de exhibicion
        LEA     DX,PROMPT
        INT     21H
        RET
PETIC 	ENDP


;	Acepta PETIC del nombre
;===============================================================================:
ENTRADA PROC    NEAR
        MOV     AH,0AH			;Peticion de teclado
        LEA     DX,PARAM		;  Entrada
        INT     21H
        RET
ENTRADA ENDP


;	Fija beep y delimitador '$'
;===============================================================================:
CODIGO PROC    NEAR
        MOV     BH,00			;Reemplaza caracter Enter (0D)
        MOV     BL,NLONG		;  con el del beep (07)
        MOV     CAMPO[BX],07
        MOV     CAMPO[BX+1],'$'		;Pone el delimitador de exhibicion
        RET
CODIGO ENDP


;	Centra y muestra el nombre
;===============================================================================:
CENTRAR PROC    NEAR
        MOV     DL,NLONG		;Localiza columna central
        SHR     DL,1 			;  divide longidud en 2,
        NEG     DL			;  invierte el seguro
        ADD     DL,40			;  suma 40
        MOV     DH,12			;Centra la fila
        CALL    CURSOR			;Fija el cursor
        MOV     AH,09H
        LEA     DX,CAMPO		;Muestra nombre
        INT     21H
        RET
CENTRAR ENDP



;	Limpiar pantalla
;===============================================================================:
LIMPIAR  PROC    NEAR
        MOV     AX,0600H		;Peticion de recorrido de la pantalla
        MOV     BH,30			;Color (07 para blanco y negro)
        MOV     CX,0000			;De 00,00
        MOV     DX,184FH		;A 24,79
        INT     10H
        RET
LIMPIAR  ENDP



;	Fijar fila/columna el cursor
;===============================================================================:
CURSOR PROC    NEAR 			;DX en entrada
        MOV     AH,02H			;Peticion de fijar cursor
        MOV     BH,00			;Pagina 0
        INT     10H
        RET
CURSOR ENDP
        END     BEGIN


