;***************
;**  PAG 273  **
;***************

TITLE   DESPLIEGACII (COM)



        .MODEL SMALL
        .CODE
        ORG     100H
BEGIN:  JMP     SHORT INITIAL
;===============================================================================:
MFILA 	DB      16 DUP (5 DUP(' ')), 13
MHEXAD  DB      00
DIRTAB  DB      30H, 31H, 32H, 33H, 34H, 35H, 36H, 37H, 38H, 39H
                DB      41H, 42H, 43H, 44H, 45H, 46H
;===============================================================================:
INITIAL PROC    NEAR                           ;Procedimiento principal
        CALL    LIMPIAP                         ;Limpia la pantalla
        LEA     SI, MFILA

LAZO1:
        CALL    CHEXAD                         ;Traduce
        CALL    DISPLAY                        ;  y despliega
        CMP     MHEXAD, 0FFH                   ;Es el ltimo nmero hex (FF)?
        JE      A50                            ;s, termina
        INC     MHEXAD                         ;no, obtener el siguiente hex
        JMP     LAZO1
A50:    MOV     AX, 4C00H                      ;Salir al DOS
        INT     21H                            
INITIAL    ENDP

CHEXAD  PROC    NEAR                           ;Convierte a hexadecimal
        MOV     AH,00
        MOV     AL, MHEXAD                     ;Obtiene una pareja hex
        MOV     CL, 04                         ;Fija el valor de corrimiento
        SHR     AX, CL                         ;Recorre a la derecha un dgito hex
        LEA     BX, DIRTAB                     ;Designa la direccin de la tabla
        XLAT                                   ;Traduce hex
        MOV     [SI], AL                       ;Almacena el carcter izquierdo

        MOV     AL, MHEXAD
        AND     AL, 0FH                        ;Limpia el dgito hex de la izquierda
        XLAT                                   ;Traduce hex
        MOV     [SI] +1, AL                    ;Almacena el carcter de la derecha
        RET
CHEXAD  ENDP
DISPLAY PROC    NEAR     			;Despliega
        MOV     AL,MHEXAD
        MOV     [SI]+3, AL
        CMP     AL, 1AH				;Es el primer caracter EOF?
        JE      LAZO2				;  si, pasar
        CMP     AL, 07H				;Es menor que 7?
        JB      LAZO3				;  si,ok
        CMP     AL,10H				;Es mayor o igual que 16?
        JAE     LAZO3				;  si,ok
LAZO2:						;  en caso contrario forzar un espacio en blanco
        MOV     BYTE PTR [SI]+3, 20H
LAZO3:
        ADD     SI, 05				;Siguiente lugar de la linea
        LEA     DI, MFILA +80
        CMP     DI, SI				;Esta llena la lina?
        JNE     LAZO4				;  no, pasar
        MOV     AH, 40H				;  si, peticion de despliegue
        MOV     BX, 01 				;Manejador de archivo
        MOV     CX, 81				;Toda la linea
        LEA     DX, MFILA
        INT     21H
        LEA     SI, MFILA			;Redesigna linea de despliegue

LAZO4:    RET
DISPLAY   ENDP

LIMPIAP  PROC    NEAR                            ;Limpia la pantalla
        MOV     AX, 06000H                      
        MOV     BH, 61H                         ;atributo
        MOV     CX, 000
        MOV     DX, 184FH
        INT     10H
        RET
LIMPIAP ENDP
        END     BEGIN


