
TITLE   VIDEOINVERSO (EXE)
	EXTRN	INDEX:FAR		;para retornar al menu
        .MODEL  SMALL
        .STACK  64
;===============================================================================:
        .DATA
NPARAM 	LABEL   BYTE			;Lista de parametros
LMAXIMA DB      20			;  Longitud maxima del nombre
NLONG 	DB      ?			;  numero de caracteres introducidos
CAMPO 	DB      20 DUP(' ')		;  para el nombre

COL     DB      00
CONTER  DB      ?
PROMPT  DB      'Video Inverso:? '
XFILA   DB      00
;===============================================================================:
        .CODE
VIDEOINVERSO   PROC    FAR
	PUBLIC	VIDEOINVERSO		;Aca se declara como procedimiento publico
        MOV     AX,@DATA		;Inicializa el registro
        MOV     DS,AX			;  de segmentos
        MOV     ES,AX
        MOV     AX,0600H
        CALL    SCREEN 			;Limpia la pantalla
LAZO1:
        MOV     COL,00			;Establece la columna a cero
        CALL    FCURSO
        CALL    DISPLAY			;Muestra el prompt
        CALL    AENTRADA			;Proporciona entrada de nombre
        CMP     NLONG,00		;No hay nombre? (indica el final)
        JNE     LAZO2
        MOV     AX,0600H
        CALL    SCREEN			;Si es asi, limpiar la pantalla,
	call	INDEX			;Retornar al menu
LAZO2:
        CALL    iNOMBRE			;Desplegar el nombre
        JMP     LAZO1
VIDEOINVERSO   ENDP

;	Muestra la indicacion
;===============================================================================:
DISPLAY PROC    NEAR
        LEA     SI,PROMPT		;Designa la direccion de la indicacion
        MOV     CONTER,17
LAZO4:
        MOV     BL,71H			;Video inverso
        CALL    DISPLAY40		;Rutina de despliegue
        INC     SI			;Caracter siguiente de palabra
        INC     COL			;Columna siguiente
        CALL    FCURSO			;Fija cursor
        DEC     CONTER			;Cuenta descendente
        JNZ     LAZO4			;Repite el ciclo n veces
        RET
DISPLAY ENDP
;	Acepta la entrada de la palabra
;===============================================================================:
AENTRADA PROC    NEAR
        MOV     AH,0AH			;Peticion de entrada
        LEA     DX,NPARAM		;  desde teclado
        INT     21H
        RET
AENTRADA ENDP
;	Despliega el nombre en video inverso y con intermitencia
;===============================================================================:
iNOMBRE PROC    NEAR
        LEA     SI,CAMPO		;Inicializa el nombre
        MOV     COL,40			;Designa la columna en la pantalla
LAZO3:
        CALL    FCURSO			;Fija cursor
        MOV     BL,0F1H			;Video inverso e intermitencia
        CALL    DISPLAY40			;Rutina de despliegue
        INC     SI			;Caracter siguiente en el nombre
        INC     COL			;Siguiente columna de la pantalla
        DEC     NLONG			;Disminuye la cuenta de la long. de nombre
        JNZ     LAZO3			;Repite el ciclo n veces

        CMP     XFILA,20			;Cerca del borde inferior de la pantalla
        JAE     LAZO5
        INC     XFILA			;  no, incrementa la linea
        RET
LAZO5:
        MOV     AX,0601H 		;  si,
        CALL    SCREEN			;  recorre la pantalla
        RET
iNOMBRE ENDP
;	Despliegue de caracter
;===============================================================================:
DISPLAY40 PROC    NEAR			;BL (Atributo se designa antes)
        MOV     AH,09H			;Peticion de despliegue
        MOV     AL,[SI]			;Obtiene el caracter de nombre
        MOV     BH,00			;No pagina
        MOV     CX,01			;Un caracter
        INT     10H
        RET
DISPLAY40 ENDP
;	Recorre la pantalla
;===============================================================================:
SCREEN  PROC    NEAR			;AX se designa antes
        MOV     BH,17H			;Blanco sobre azul
        MOV     CX,0000
        MOV     DX,184FH		;Pantalla completa
        INT     10H
        RET
SCREEN  ENDP
;	Fija el cursor en la fila/columna 00,00
;===============================================================================:
FCURSO PROC    NEAR
        MOV     AH,02H
        MOV     BH,00			;Pagina
        MOV     DH,XFILA			;Linea
        MOV     DL,COL			;Columna
        INT     10H
        RET
FCURSO ENDP
        END     VIDEOINVERSO
                     




;===============================================================================:
;   Fuente: 									:
;   Lenguaje Ensamblador y Programacion para PC IBM y Compatibles		:
;   Peter Abel.									:
;   Capitulo 10 Pag. 169 - P10NMSRC								:
;===============================================================================:
