;***************
;**  PAG 276  **
;***************



TITLE   ORDENA (EXE)			 
        .MODEL  SMALL
        .STACK  64
;===============================================================================:
        .DATA
NPARAM 	LABEL   BYTE			;Lista de parametros de nombre:
LONGMAX DB      21			;  longitud maxima
NCARACTE DB      ?			;  no. de caracteres ingresados para
CAMPON DB      21 DUP(' ')		;  nombre

SALTO   DB      13,10,'$'
FINDIR 	DW      ?
MSG	DB	'Nombre? ','$'
NOMCTR	DB	00
NOMTAB	DB	30 DUP(20 DUP(' '))	;Tabla de nombres
NOMGUAR	DB	20 DUP(?),13,10,'$'	
DESIG	DB	00
;===============================================================================:
	.CODE
EMPEZAR	PROC	FAR
	MOV	AX,@data		;Inicializa los registros
	MOV	DS,AX			;  DS y ES
	MOV	ES,AX
	CLD
	CALL	LIMPIAP			;Limpia la pantalla
	CALL	FCURSOR			;Fija el cursor
	LEA	DI,NOMTAB
LAZO1:
	CALL	LEERNOM			;Acepta un nombre
	CMP	NCARACTE,00		;Existen mas nombres?
	JZ	LAZO2			;  no, ir a ordenar
	CMP	NOMCTR,30		;Han ingresado 30 nombres?
	JE	LAZO2			;  si, ir a ordenar
	CALL	GUARDN			;Almacenar en tabla nombre ingresado
	JMP	LAZO1
LAZO2:					;Fin de la entrada
	CALL	LIMPIAP			;Limpia la pantalla
	CALL	FCURSOR			;Fija el cursor
	CMP	NOMCTR,01		;Se ingreso uno o ningun nombre?
	JBE	LAZO3			;  Si, salir
	CALL	ORDENARN			;Ordenar los nombres almacenados
	CALL	DISPLAYN			;Mostrar los nombres ordenados

LAZO3:	MOV	AX,4C00H		;Salir al DOS
	INT	21H
EMPEZAR	ENDP

;	Acepta los nombres como entrada
;===============================================================================:
LEERNOM	PROC
	MOV	AH,09H
	LEA	DX,MSG		;Despliega la indicacion
	INT	21H
	MOV	AH,0AH			
	LEA	DX,NPARAM		;Acepta nombres
	INT	21H
	MOV	AH,09H
	LEA	DX,SALTO			;Retorno de carro y avance de linea
	INT	21H

	MOV	BH,00			;Limpia caracteres despues del nombre
	MOV	BL,NCARACTE		;Obtiene el contador de caracteres
	MOV	CX,21
	SUB	CX,BX			;Calcula la longitud restante
LAZO4:
	MOV	CAMPON[BX],20H		;Designa el nombre en blanco
	INC	BX
	LOOP	LAZO4
	RET
LEERNOM	ENDP

;	Almacena nombre en la tabla
;===============================================================================:
GUARDN	PROC
	INC	NOMCTR			;Suma al numero de nombres
	CLD
	LEA	SI,CAMPON
	MOV	CX,10			;Diez palabras
	REP	MOVSW
	RET
GUARDN	ENDP

;	Ordena los nombres de la tabla
;===============================================================================:
ORDENARN	PROC
	SUB	DI,40			;Designa la direccion de detencion
	MOV	FINDIR,DI
LAZO5:
	MOV	DESIG,00		;Designa el inicio
	LEA	SI,NOMTAB		;  de la tabla
LAZO6:
	MOV	CX,20			;Longitud de comparacion
	MOV	DI,SI
	ADD	DI,20			;Nombre siguiente por comparar
	MOV	AX,DI			;
	MOV	BX,SI
	REPE CMPSB			;Compara el nombre con el siguiente
	JBE	LAZO7			;  no hay intercambio
	CALL	NCAMBIO		;  intercambio
LAZO7:
	MOV	SI,AX
	CMP	SI,FINDIR		;Es el fin de la tabla?
	JBE	LAZO6			;  no, continuar
	CMP	DESIG,00		;Hubo algun intercambio?
	JNZ	LAZO5			;  si, continuar
	RET				;  no, fin del ordenamiento
ORDENARN	ENDP

;	Intercambia entradas de la tabla
;===============================================================================:
NCAMBIO	PROC
	MOV	CX,10			;No. de caracteres
	LEA	DI,NOMGUAR
	MOV	SI,BX
	REP MOVSW			;Mueve el elemento menor para guardarlo

	MOV	CX,10			;No. caracteres
	MOV	DI,BX
	REP MOVSW			;Mueve el mayor al menor

	MOV	CX,10
	LEA	SI,NOMGUAR
	REP MOVSW			;Mueve el guardado al elemento mayor
	MOV	DESIG,01		;Seala que se realizo un intercambio
	RET
NCAMBIO	ENDP

;	Despliega los nombres ordenados
;===============================================================================:
DISPLAYN	PROC
	LEA	SI,NOMTAB
LAZO8:
	LEA	DI,NOMGUAR		;Inicializa el principio de la tabla
	MOV	CX,10			;Cuenta los ciclos
	REP MOVSW
	MOV	AH,09H			;Peticion de despliegue
	LEA	DX,NOMGUAR		
	INT	21H
	DEC	NOMCTR			;Es el ultimo?
	JNZ	LAZO8			;  no, repetir el ciclo
	RET				;  si, salir
DISPLAYN	ENDP

;	Limpia la pantalla
;===============================================================================:
LIMPIAP	PROC
	MOV	AX,0600H
	MOV	BH,61H			;Atributo
	MOV	CX,00			;Pantalla completa
	MOV	DX,184FH
	INT	10H
	RET
LIMPIAP	ENDP

;	Coloca el cursor
;===============================================================================:
FCURSOR	PROC
	MOV	AH,02H			;Peticion de colocar el cursor
	MOV	BH,00			;Pagina 0
	MOV	DX,00
	INT	10H
	RET
FCURSOR	ENDP
	END	EMPEZAR

	

